## Custom Assets Library Plugin Integrated Extension
The Custom Assets Library Plugin Integrated Extension adds additional functionality such as auras, effects, filters, transformations,
animations and sound to custom assets. Previously this was part of CALP but it has been moved to it own plugin so that if this more
complex plugin fails due to a BR update, the core CALP code can still function.

## Installing With R2ModMan
This package is designed specifically for R2ModMan and Talespire. 
You can install them via clicking on "Install with Mod Manager" or using the r2modman directly.

## Player Usage
Once enabled, this plugin provides additional functionality as outlined below. 

### Default Keyboard Shortcuts

CALP has a bunch of keyboard shortcuts for triggering additional functionality. The default keys can be reconfigured to other
keys by editing the R2ModMan configuration for the CALP plugin. Keyboard shortcuts are divided into two sub-sections: functionality
triggers and asset spawn modifeirs. 

#### Functionality Triggers

Press these keys while a mini is selected to trigger the corresponding effect if supported.

```
+-----------------+------------------------------------------------------------------+
| Modifier Keys   | Results                                                          |
+-----------------+------------------------------------------------------------------+
+-----------------+------------------------------------------------------------------+
| LControl + 1    | Trigger Animation "Anim01"                                       |
+-----------------+------------------------------------------------------------------+
| LControl + 2    | Trigger Animation "Anim02"                                       |
+-----------------+------------------------------------------------------------------+
| LControl + 3    | Trigger Animation "Anim03"                                       |
+-----------------+------------------------------------------------------------------+
| LControl + 4    | Trigger Animation "Anim04"                                       |
+-----------------+------------------------------------------------------------------+
| LControl + 5    | Trigger Animation "Anim05"                                       |
+-----------------+------------------------------------------------------------------+
| LControl + 6    | Trigger Animation "Anim06"                                       |
+-----------------+------------------------------------------------------------------+
| LControl + 7    | Trigger Animation "Anim07"                                       |
+-----------------+------------------------------------------------------------------+
| LControl + 8    | Prompt for animation name and play it                            |
+-----------------+------------------------------------------------------------------+
| LControl + 9    | Start playing associated audio                                   |
+-----------------+------------------------------------------------------------------+
| LControl + 0    | Stop playing animation and audio                                 |
+-----------------+------------------------------------------------------------------+
+-----------------+------------------------------------------------------------------+
| RControl + A    | Analyze and log selected minis' renderer information             |
+-----------------+------------------------------------------------------------------+
``` 

#### Asset Spawn Modifiers

When selecting an asset from the Talespire Library the asset will be loaded based on the kind specified in the asset bundle or as a
creature if the asset does not specify the kind in its info.txt file. However, it is possible to override the kind indicated in the
asset bundle with a different kind by holding down the corresponding modifier key while selecting it from the library and when placing
it down (if applicable). The following tables show what modifier keys select what kind:

```
+-----------------+------------------------------------------------------------------+
| Modifier Keys   | Resulting Kind                                                   |
+-----------------+------------------------------------------------------------------+
+-----------------+------------------------------------------------------------------+
| None            | Uses kind specified in asset bundle or creature if not specified |
+-----------------+------------------------------------------------------------------+
| Left Shift      | Processes spawn as if the kind was creature                      |
+-----------------+------------------------------------------------------------------+
| Right Shift     | Processes spawn as if the kind was transform                     |
+-----------------+------------------------------------------------------------------+
| Left Control    | Processes spawn as if the kind was effect                        |
+-----------------+------------------------------------------------------------------+
| Right Control   | Processes spawn as if the kind was aura                          |
+-----------------+------------------------------------------------------------------+
| Left Alt        | Processes spawn as if the kind was audio                         |
+-----------------+------------------------------------------------------------------+
| Right Alt       | Processes spawn as if the kind was filter                        |
+-----------------+------------------------------------------------------------------+
```

See Custom Assets Library Plugin (CALP) for more details on the meanibng of the different kinds.


### Asset Types

To avoid duplication, see the CALP documentation for the various differences between the different kind of assets.


## Changelog
```
1.3.0: Unified on-load and on-demand code to handle shaders the same way.
1.2.0: Reworked shader setting code to fix "already loaded bug" issue.
1.1.0: Improved modifier key detection
1.1.0: Added more "already loaded" protection
1.1.0: Bug fix with prefab property
1.0.1: Bug fix guess for "already loaded" issue
1.0.1: Bug fix for laggy effects
1.0.1: Bug fix for older registrations without PREFAB key
1.0.0: Supports partial implemntation of Multi Slabs. As of now, Multi-Slabs don't respect the Height Bar. 
1.0.0: Supports Animations and Sound.
1.0.0: Supports Effects including hiding effects by Hide function and Height Bar.
1.0.0: Initial release.
```

Shoutout to Hollofoxes [Patreons](https://www.patreon.com/HolloFox) recognising their
mighty contribution to his caffeine addiction:
- John Fuller
- [Tales Tavern](https://talestavern.com/) - MadWizard

Also checkout LordAshes [donation page](https://lordashes.ca/TalespireDonate/Donate.php)
